//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

bool bothEvenOrOdd (int elem1, int elem2)
{
  return elem1 % 2 == elem2 % 2;
}


int main()
{
  vector<int> coll1;
  list<int> coll2;

  INSERT_ELEMENTS(coll1,1,7);
  INSERT_ELEMENTS(coll2,3,9);

  PRINT_ELEMENTS(coll1,":\n");
  PRINT_ELEMENTS(coll2,":\n");

  //    
  if (equal (coll1.begin(), coll1.end(),  //  
             coll2.begin())) {            //  
    cout << ToRus(" == ") << endl;
  }
  else {
    cout << ToRus(" != ") << endl;
  }

  //   / 
  if (equal (coll1.begin(), coll1.end(),  //  
             coll2.begin(),               //  
             bothEvenOrOdd)) {            //  
      cout << ToRus("   /") << endl;
  }
  else {
      cout << ToRus("   /") << endl;
  }


  getch();
  return 0;
}

//---------------------------------------------------------------------------